/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/GUIForms/JFrame.java to edit this template
 */
package pos;

import Service.CustomerService;
import java.awt.Font;
import java.util.List;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.ListSelectionModel;
import javax.swing.UIManager;
import javax.swing.table.DefaultTableModel;
import model.Customer;

/**
 *
 * @author Acer
 */
public class SearchCustomerForm extends javax.swing.JFrame {

    private CustomerService cusService;
    List<Customer> cusList;
    DefaultTableModel model;
    POSPanel posPanel;

    /**
     * Creates new form SearchCustomerForm
     */
    public SearchCustomerForm() {
        this.setUndecorated(true);
        initComponents();
        tblCustomers.getTableHeader().setFont(new Font("Tahoma", Font.BOLD, 14));
        tblCustomers.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        UIManager.put("OptionPane.messageFont", new Font("Tahoma", Font.BOLD, 14));
        setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
        model = (DefaultTableModel) tblCustomers.getModel();
        cusService = new CustomerService();
        cusList = cusService.getCustomers();
        for (Customer c : cusList) {
            model.addRow(new Object[]{c.getCusId(), c.getCusName(), c.getCusSurname(), c.getCusTel(), c.getCusPoint(), c.getCusPurchaseCount(), c.getCusDiscount()});
        }
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        pnlBackground = new javax.swing.JPanel();
        scpCustomer = new javax.swing.JScrollPane();
        tblCustomers = new javax.swing.JTable();
        btnSelectRow = new javax.swing.JButton();
        btnSearch = new javax.swing.JButton();
        cmbCategory = new javax.swing.JComboBox<>();
        btnCategory = new javax.swing.JLabel();
        txtSearch = new javax.swing.JTextField();
        btnClose = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("ค้นหาสมาชิก");
        setBackground(new java.awt.Color(255, 255, 255));
        setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        setFont(new java.awt.Font("Tahoma", 0, 14)); // NOI18N

        pnlBackground.setBackground(new java.awt.Color(255, 255, 255));
        pnlBackground.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(84, 70, 63), 2));
        pnlBackground.setForeground(new java.awt.Color(255, 255, 255));

        scpCustomer.setBackground(new java.awt.Color(255, 255, 255));
        scpCustomer.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(84, 70, 63)));

        tblCustomers.setBackground(new java.awt.Color(255, 255, 255));
        tblCustomers.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(84, 70, 63)));
        tblCustomers.setFont(new java.awt.Font("Tahoma", 0, 14)); // NOI18N
        tblCustomers.setForeground(new java.awt.Color(84, 70, 63));
        tblCustomers.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "รหัสลูกค้า", "ชื่อ", "นามสกุล", "เบอร์โทร", "แต้ม", "จำนวนครั้งที่ซื้อ", "ส่วนลดสมาชิก"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, false, false, false, false, false, false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        tblCustomers.setSelectionBackground(new java.awt.Color(85, 68, 68));
        tblCustomers.setSelectionForeground(new java.awt.Color(255, 255, 255));
        scpCustomer.setViewportView(tblCustomers);

        btnSelectRow.setBackground(new java.awt.Color(84, 70, 63));
        btnSelectRow.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        btnSelectRow.setForeground(new java.awt.Color(255, 255, 255));
        btnSelectRow.setText("เลือกรายการ");
        btnSelectRow.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnSelectRow.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSelectRowActionPerformed(evt);
            }
        });

        btnSearch.setBackground(new java.awt.Color(84, 70, 63));
        btnSearch.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        btnSearch.setForeground(new java.awt.Color(255, 255, 255));
        btnSearch.setText("ค้นหา");
        btnSearch.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSearchActionPerformed(evt);
            }
        });

        cmbCategory.setBackground(new java.awt.Color(84, 70, 63));
        cmbCategory.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        cmbCategory.setForeground(new java.awt.Color(255, 255, 255));
        cmbCategory.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "รหัสลูกค้า", "ชื่อ", "นามสกุล", "เบอร์โทร" }));

        btnCategory.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        btnCategory.setForeground(new java.awt.Color(84, 70, 63));
        btnCategory.setText("หมวดหมู่ :");

        txtSearch.setBackground(new java.awt.Color(211, 197, 186));
        txtSearch.setFont(new java.awt.Font("Tahoma", 0, 12)); // NOI18N
        txtSearch.setForeground(new java.awt.Color(84, 70, 63));
        txtSearch.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                txtSearchActionPerformed(evt);
            }
        });

        btnClose.setBackground(new java.awt.Color(255, 255, 255));
        btnClose.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        btnClose.setForeground(new java.awt.Color(84, 70, 63));
        btnClose.setText("X");
        btnClose.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCloseActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout pnlBackgroundLayout = new javax.swing.GroupLayout(pnlBackground);
        pnlBackground.setLayout(pnlBackgroundLayout);
        pnlBackgroundLayout.setHorizontalGroup(
            pnlBackgroundLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlBackgroundLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pnlBackgroundLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(pnlBackgroundLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                        .addGroup(pnlBackgroundLayout.createSequentialGroup()
                            .addComponent(txtSearch, javax.swing.GroupLayout.PREFERRED_SIZE, 398, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                            .addComponent(btnCategory, javax.swing.GroupLayout.PREFERRED_SIZE, 60, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                            .addComponent(cmbCategory, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addGap(117, 117, 117)
                            .addComponent(btnSearch, javax.swing.GroupLayout.PREFERRED_SIZE, 96, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addComponent(btnSelectRow, javax.swing.GroupLayout.PREFERRED_SIZE, 96, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(scpCustomer, javax.swing.GroupLayout.PREFERRED_SIZE, 810, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(btnClose))
                .addContainerGap(14, Short.MAX_VALUE))
        );
        pnlBackgroundLayout.setVerticalGroup(
            pnlBackgroundLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlBackgroundLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(btnClose)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(pnlBackgroundLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btnSearch)
                    .addComponent(cmbCategory, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(btnCategory)
                    .addComponent(txtSearch, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addComponent(scpCustomer, javax.swing.GroupLayout.PREFERRED_SIZE, 192, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(btnSelectRow)
                .addContainerGap())
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(pnlBackground, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(pnlBackground, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void btnSearchActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSearchActionPerformed
        boolean searchFound = false;
        int searchRow = -1;
        if (!txtSearch.getText().equals("")) {
            if (cmbCategory.getSelectedItem().toString().equals("รหัสลูกค้า")) {
                searchRow = 0;
            } else if (cmbCategory.getSelectedItem().toString().equals("ชื่อ")) {
                searchRow = 1;
            } else if (cmbCategory.getSelectedItem().toString().equals("นามสกุล")) {
                searchRow = 2;
            } else if (cmbCategory.getSelectedItem().toString().equals("เบอร์โทร")) {
                searchRow = 3;
            }

            for (int i = 0; i < tblCustomers.getRowCount(); i++) {
                if (tblCustomers.getModel().getValueAt(i, searchRow).toString().equals(txtSearch.getText())) {
                    searchFound = true;
                    JFrame f = new JFrame();
                    int result = JOptionPane.showConfirmDialog(null, "ข้อมูลลูกค้าที่พบ\n" + cusList.get(i) + "\nต้องการใช้ข้อมูลลูกค้านี้หรือไม่", "พบข้อมูลลูกค้าที่ค้นหา",
                            JOptionPane.YES_NO_OPTION,
                            JOptionPane.INFORMATION_MESSAGE);
                    if (result == JOptionPane.YES_OPTION) {
                        posPanel.setCustomer(cusList.get(i));
                        this.setVisible(false);
                    }
                }
            }

            if (searchFound == false) {
                JFrame f = new JFrame();
                JOptionPane.showMessageDialog(f, "ไม่พบข้อมูลลูกค้า\nจากการค้นหา : " + txtSearch.getText() + "\nในหมวด " + cmbCategory.getSelectedItem().toString(), "ไม่พบข้อมูลลูกค้าที่ค้นหา", JOptionPane.INFORMATION_MESSAGE);
            }
        } else {
            JFrame f = new JFrame();
            JOptionPane.showMessageDialog(f, "ข้อมูลที่ค้นหาไม่ถูกต้อง โปรดใส่ข้อมูลในช่องค้นหา", "ข้อมูลที่ค้นหาไม่ถูกต้อง", JOptionPane.INFORMATION_MESSAGE);
            txtSearch.requestFocus();
        }
    }//GEN-LAST:event_btnSearchActionPerformed

    private void btnSelectRowActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSelectRowActionPerformed
        int selectedRow = tblCustomers.getSelectedRow();
        if (selectedRow >= 0) {
            int result = JOptionPane.showConfirmDialog(null, "ข้อมูลลูกค้าที่เลือก\n" + cusList.get(selectedRow) + "\nต้องการใช้ข้อมูลลูกค้านี้หรือไม่", "ข้อมูลลูกค้าที่เลือก",
                    JOptionPane.YES_NO_OPTION,
                    JOptionPane.INFORMATION_MESSAGE);
            if (result == JOptionPane.YES_OPTION) {
                posPanel.setCustomer(cusList.get(selectedRow));
                this.setVisible(false);
            }
        }
    }//GEN-LAST:event_btnSelectRowActionPerformed

    private void btnCloseActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCloseActionPerformed
        this.setVisible(false);
    }//GEN-LAST:event_btnCloseActionPerformed

    private void txtSearchActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_txtSearchActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_txtSearchActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(SearchCustomerForm.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(SearchCustomerForm.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(SearchCustomerForm.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(SearchCustomerForm.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new SearchCustomerForm().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel btnCategory;
    private javax.swing.JButton btnClose;
    private javax.swing.JButton btnSearch;
    private javax.swing.JButton btnSelectRow;
    private javax.swing.JComboBox<String> cmbCategory;
    private javax.swing.JPanel pnlBackground;
    private javax.swing.JScrollPane scpCustomer;
    private javax.swing.JTable tblCustomers;
    private javax.swing.JTextField txtSearch;
    // End of variables declaration//GEN-END:variables

    void setPOSPanel(POSPanel posPanel) {
        this.posPanel = posPanel;
    }
}
